#!./perl
#************************************************************************
#myri_unconfigure_kernel.pl - undoes a myricom kernel configuration
#1.0
# 
#Copyright (c) 1995 University of Southern California.
#All rights reserved.                                            
#                                                                
#Redistribution and use in source and binary forms are permitted
#provided that the above copyright notice and this paragraph are
#duplicated in all such forms and that any documentation, advertising
#materials, and other materials related to such distribution and use
#acknowledge that the software was developed by the University of
#Southern California, Information Sciences Institute.  The name of the
#University may not be used to endorse or promote products derived from
#this software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
#WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#************************************************************************

@INC = ( @INC, "." );

require "request.pl";

$arch=`arch -k` || "sun";
chop $arch if substr($arch,-1,1) eq "\n";
$kpath="/usr/sys";

print STDERR <<"END";
This script undoes a myricom kernel installation.  All it really does is
rename files with a .atomic.hold extention back to what they were.
END

$kpath = &get_string("Where is the source directory tou want to restore",$kpath,"-d && -r && -x","Bad directory - check spelling & permissions",STDERR);
$arch=&get_string("What is the architecture of your machine",$arch, "-d \"$kpath/\$_\"","Bad architecture - no source tree in $kpath",STDERR);

if (&check("$kpath/sun/conf.c","MYRI") ) {
	rename("$kpath/sun/conf.c.atomic.hold","$kpath/sun/conf.c") || 
		die "Can't restore $kpath/sun/conf.c :$!\n";
	print STDERR <<"END";
$kpath/sun/conf.c restored from $kpath/sun/conf.c.atomic.hold

END
}
else { 
	print STDERR <<"END";
$kpath/sun/conf.c has not been modified.  (no changes made)

END
}


$conf="$kpath/$arch/conf/files";
$backup="$kpath/$arch/conf/files.atomic.hold";

if (&check($conf,"myri")) {
	rename($backup,$conf) || die "Can't restore $conf\n";
	print STDERR <<"END";
$conf restored from $backup

END
}
else { 
	print STDERR <<"END";
$conf has not been modified (no changes made)
END
}

if ( $< == 1 && &y_or_n("Remove device files?","y") ) {
	for ("/dev/myri0","/dev/mlanai0") {
		-e && -c && unlink;
	}
}
