#************************************************************************
#request.pl - prompting routines for the myri_stuff
#1.0
# 
#Copyright (c) 1995 University of Southern California.
#All rights reserved.                                            
#                                                                
#Redistribution and use in source and binary forms are permitted
#provided that the above copyright notice and this paragraph are
#duplicated in all such forms and that any documentation, advertising
#materials, and other materials related to such distribution and use
#acknowledge that the software was developed by the University of
#Southern California, Information Sciences Institute.  The name of the
#University may not be used to endorse or promote products derived from
#this software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
#WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#************************************************************************


sub y_or_n {
# Prompt a yes or no question and return 1 on yes and 0 on no
# A "yes" is any line beginning with y, a "no" is anything else 
# you can pass in a filehandle as well

	local($prompt,$default,$filehandle) = @_;
	local($_);

	$filehandle = STDOUT unless $filehandle;
	print $filehandle "$prompt [$default] ";
	chop ($_ = <STDIN>);
	$_ = "$default" if $_ eq "";
	/^y/ ? 1 : 0;
}

sub get_string {
# This prompts for a string with a default value and returns only when the
# string entered meets $condition.  When $condition is evaluated the string
# is in $_.  The prompt is issued on STDOUT by default

	local($prompt,$default,$condition,$emsg,$filehandle) = @_;
	local($_);

	$condition = 1 if $condition eq "";
	$filehandle = STDOUT unless $filehandle;

	do { 
		print $filehandle $default ? "$prompt [$default] " : "$prompt ";
		chop ( $_ = <STDIN>);
		$_ = $default if $_ eq "" ;
	} while ( !eval $condition && print STDERR "$emsg\n" );
	$_;
}

sub check {
# check $file for $pat

	local($file,$pat) = @_;
	local($OK);

	$OK=0;
	open(F,$file) || die "Can't open $file : $!\n";
	while (<F>) { /$pat/ && ($OK = 1); }
	close(F);
	$OK;
}

1;
